diff options
author | sven.panne@aedion.de <unknown> | 2007-08-25 13:30:52 +0000 |
---|---|---|
committer | sven.panne@aedion.de <unknown> | 2007-08-25 13:30:52 +0000 |
commit | 2d2393de269d8c5c9043a047e6ca652f64358610 (patch) | |
tree | 7fb6fac75861f6483a6d0989c2582e25b0e67748 /boot | |
parent | 700148432ac5bd85013670036cae7273abc75db3 (diff) | |
download | haskell-2d2393de269d8c5c9043a047e6ca652f64358610.tar.gz |
Overhaul boot script
* Call autoreconf only if necessary, avoiding a strict tool dependency.
* Be a good *nix citizen and don't clutter the output when everything is fine.
* Make a few more scripts executable.
Diffstat (limited to 'boot')
-rw-r--r-- | boot | 45 |
1 files changed, 22 insertions, 23 deletions
@@ -1,29 +1,28 @@ -#!/bin/sh - +#! /bin/sh set -e -for d in `cat libraries/core-packages` -do - if test ! -d libraries/$d - then - echo "Looks like you're missing libraries/$d," - echo "maybe you haven't done './darcs-all get'?" - exit 1 - fi +# Check that we have all core packages. +for dir in `cat libraries/core-packages`; do + if test ! -d libraries/$dir; then + echo "Looks like you're missing libraries/$dir, maybe you haven't done './darcs-all get'?" >&2 + exit 1 + fi done -chmod +x push-all - -echo "Booting ." -autoreconf - -for lib in libraries/*; do - if test -e $lib/configure.ac - then - echo "Booting $lib" - cd $lib - autoreconf - cd ../.. - fi +# We don't recurse into the library packages with autoreconf anymore, so we +# have to do this manually. To avoid a strict dependency on autoreconf, we +# are careful to call autoreconf only when configure does not exist yet or the +# corresponding configure.ac is newer. This would be dead easy if every shell +# supported the "-nt" option for "test", but this is not the case. The only +# portable solution seems to be via find's "-newer" option or to basically give +# up and replace find with perl: :-P +# +# perl -e 'print "configure.ac\n" if -M "configure.ac" < -M "configure"' +for dir in . libraries/*; do + if test -f $dir/configure.ac; then + ( cd $dir ; { test ! -f configure || test -n "`find configure.ac -newer configure`"; } && autoreconf ) + fi done +# Alas, darcs doesn't handle file permissions, so fix a few of them. +chmod +x boot darcs-all push-all |